KServiceTypeProfile Class Reference

`#include <kuserprofile.h>`

## Public Types

typedef QValueList< KServiceOffer > | OfferList

## Public Member Functions

int | preference (const QString &_service) const
bool | allowAsDefault (const QString &_service) const
OfferList | offers () const

## Static Public Member Functions

static KService::Ptr | preferredService (const QString &serviceType, const QString &genericServiceType)
static KServiceTypeProfile * | serviceTypeProfile (const QString &servicetype, const QString &genericServiceType=QString::null)
static OfferList | offers (const QString &servicetype, const QString &genericServiceType=QString::null)
static const QPtrList < KServiceTypeProfile > & | serviceTypeProfiles ()
static void | clear ()
static void | setConfigurationMode ()
static void | unsetConfigurationMode ()
static bool | configurationMode ()

## Protected Member Functions

| KServiceTypeProfile (const QString &serviceType, const QString &genericServiceType=QString::null)
void | addService (const QString &_service, int _preference=1, bool _allow_as_default=true)

## Detailed Description

KServiceTypeProfile represents the user's preferences for services of a service type.

It consists of a list of services (service offers) for the service type that is sorted by the user's preference. KTrader uses KServiceTypeProfile to sort its results, so usually you can just use KTrader to find the user's preferred service.

See also
  KService
  KServiceType
  KServiceOffer
  KTrader Represents the user's preferences for services of a service type

Definition at line 117 of file kuserprofile.h.

## Constructor & Destructor Documentation

KServiceTypeProfile::KServiceTypeProfile | ( | const QString & | serviceType,
|  | const QString & | genericServiceType = `QString::null`
| ) |  |

protected

Constructor is called when the user profile is read for the first time.

Parameters

  serviceType | the service type (e.g. a MIME type)
  genericServiceType | the generic service type (e.g. "Application" or "KParts/ReadOnlyPart"). Can be QString::null, then the "Application" generic type will be used

Definition at line 194 of file kuserprofile.cpp.

## Member Function Documentation

void KServiceTypeProfile::addService | ( | const QString & | _service,
|  | int | _preference = `1`,
|  | bool | _allow_as_default = `true`
| ) |  |

protected

Add a service to this profile.

Parameters

  _service | the name of the service
  _preference | the user's preference value, must be positive, bigger is better
  _allow_as_default | true if the service should be used as default

Definition at line 206 of file kuserprofile.cpp.

bool KServiceTypeProfile::allowAsDefault | ( | const QString & | _service | ) | const

Deprecated:
  Remove in KDE 4, unused. Checks whether the given `_service` can be used as default.
  Parameters

    _service | the name of the service to check

  Returns
    true if allowed as default

Definition at line 225 of file kuserprofile.cpp.

void KServiceTypeProfile::clear | ( |  | ) |

static

Clear all cached information.

Definition at line 99 of file kuserprofile.cpp.

KServiceTypeProfile::OfferList KServiceTypeProfile::offers | ( |  | ) | const

Returns the list of all service offers for the service types that are represented by this profile.

Returns
  the list of KServiceOffer instances

Definition at line 260 of file kuserprofile.cpp.

KServiceTypeProfile::OfferList KServiceTypeProfile::offers | ( | const QString & | servicetype,
|  | const QString & | genericServiceType = `QString::null`
| ) |  |

static

Returns the offers associated with a given servicetype, sorted by preference.

This is what KTrader uses to get the list of offers, before applying the constraints and preferences.

If `genericServiceType` is specified, a list is returned with the offers associated with the combination of the two service types. This is almost like an "foo in ServiceTypes" constraint in the KTrader, but the difference is that to order the offers, we will look at entries specifically for those two service types. Typically, this is used for getting the list of embeddable components that can handle a given mimetype. In that case, `servicetype` is the mimetype and `genericServiceType` is "KParts/ReadOnlyPart".

Parameters

  servicetype | the service type (e.g. a MIME type)
  genericServiceType | the generic service type (e.g. "Application" or "KParts/ReadOnlyPart"). Can be QString::null, then all generic types will be included

Returns
  the list of offers witht he given parameters

Definition at line 110 of file kuserprofile.cpp.

int KServiceTypeProfile::preference | ( | const QString & | _service | ) | const

Deprecated:
  Remove in KDE 4, unused. Returns the users preference of the given service.
  Parameters

    _service | the name of the service to check

  Returns
    the user's preference number of the given `_service`, or 0 the service is unknown.

Definition at line 213 of file kuserprofile.cpp.

KService::Ptr KServiceTypeProfile::preferredService | ( | const QString & | serviceType,
|  | const QString & | genericServiceType
| ) |  |

static

Returns the preferred service for `_serviceType` and `_genericServiceType` ("Application", type of component, or null).

Parameters

  serviceType | the service type (e.g. a MIME type)
  genericServiceType | the generic service type (e.g. "Application" or "KParts/ReadOnlyPart")

Returns
  the preferred service, or 0 if no service is available

Definition at line 303 of file kuserprofile.cpp.

KServiceTypeProfile * KServiceTypeProfile::serviceTypeProfile | ( | const QString & | servicetype,
|  | const QString & | genericServiceType = `QString::null`
| ) |  |

static

Returns the profile for the requested service type.

Parameters

  servicetype | the service type (e.g. a MIME type)
  genericServiceType | the generic service type (e.g. "Application" or "KParts/ReadOnlyPart"). Can be QString::null, then the "Application" generic type will be used

Returns
  the KServiceTypeProfile with the given arguments, or 0 if not found

Definition at line 243 of file kuserprofile.cpp.

static const QPtrList<KServiceTypeProfile>& KServiceTypeProfile::serviceTypeProfiles | ( |  | ) |

inline static

Returns a list of all KServiceTypeProfiles.

Returns
  a list of all KServiceTypeProfiles

Definition at line 194 of file kuserprofile.h.

static void KServiceTypeProfile::setConfigurationMode | ( |  | ) |

inline static

This method activates a special mode of KServiceTypeProfile, in which all/all and all/allfiles are excluded from the results of the queries.

It is meant for the configuration module only.

Definition at line 207 of file kuserprofile.h.

static void KServiceTypeProfile::unsetConfigurationMode | ( |  | ) |

inline static

This method deactivates the special mode above of KServiceTypeProfile It is meant for the configuration module only.

Definition at line 215 of file kuserprofile.h.

The documentation for this class was generated from the following files:

- kuserprofile.h
- kuserprofile.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys